import { PublisherSchema } from ".";
import { DocumentNode } from "graphql";
import { EventBusPlugin } from "./VanillaEventBus";
export declare type EventBusSubscriberCb = (props: {
    key: string;
    data: {};
}) => Promise<unknown>;
export interface SubscriberConfig {
    queries: DocumentNode;
    schema: PublisherSchema;
    cb: (bus: EventBus) => EventBusSubscriberCb;
}
export interface PublisherConfig {
    schema: PublisherSchema;
}
export interface EventBusConfig {
    publisher?: PublisherConfig;
    subscriber?: SubscriberConfig;
    plugins?: EventBusPlugin[];
}
export declare type Publish = (props: {
    topicName: string;
    data: {};
}) => Promise<unknown>;
export declare abstract class EventBus {
    abstract init(): Promise<void>;
    abstract publish: Publish;
    abstract closeConsumer(): Promise<unknown>;
    abstract closePublisher(): Promise<unknown>;
}
